0%

nim-game

Nim Game – LeetCode 292

Problem

Description

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

Answer

Original

Code

1
2
3
4
5
6
class Solution {
public:
bool canWinNim(int n) {
return n & 0x3;
}
};

思路

数学题,以4为一个基本单元,因为正好是3+1,完成一个操作权交换,所以必输。于是只要是4的倍数就会输。时间复杂度$O(1)$,空间复杂度$O(1)$。
耗时$2$ ms,排名$77.79\%$

Better

思路

还没看到更好的思路。